//XBM I/O Class
//
//Load 1bit 
//Save 1bit 
//    

{$RANGECHECKS OFF}
{$WARNINGS OFF}    

unit XBMPack;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics;

//mNFNX
type
  TBWImage = class(TBitmap)
  private
   procedure BlackWhite;
  protected
  public
   procedure Assign(Source: TPersistent); override;
   procedure SaveToStream(Stream:TStream); override;
  end;

//XBM [_[/Z[o[
type
  TXBMImage = class(TBitmap)
  private
    function GetBitmapSize(LineBuf :string): integer;
  protected
    procedure CreateBWPalette ;
    function  DoIntelOder(Value :byte):byte;
  public
    procedure LoadFromStream(Stream: TStream); override;
    procedure SaveToStream(Stream: TStream); override;
  end;

type
 PRGBColor = ^TRGBColor;
 TRGBColor = array[0..32768-1] of TRGBTriple;

Var
  //݃T|[gp
  XBMWidth    : array[0..17]of char =('#','d','e','f','i','n','e',' ','d','a',
                                      't','a','_','w','i','d','t','h');
  XBMHeight   : array[0..18]of char =('#','d','e','f','i','n','e',' ','d','a',
                                      't','a','_','h','e','i','g','h','t');
  Header      : array[0..37]of char =('s','t','a','t','i','c',' ','u','n','s',
                                      'i','g','n','e','d',' ','c','h','a','r',
                                      ' ','d','a','t','a','_','b','i','t','s',
                                      '[',']',' ','=',' ','{',#13,#10);
  C_Hex       : array[0..1] of char =('0','x');
  LastString  : array[0..3] of char =(#13,#10,'}',';') ;

implementation

///////////////////////////////////////////////////////////////////////////////

////////
function _ReplaceString(Main,Search,Replace: String): String;
var
  nIndex : integer;
  nLen   : Integer;
  Buf1   : String;
  Buf2   : String;
begin
  //ꊇu...xł(^^;
  Buf2   := '';
  Buf1   := Main;
  nIndex := Pos(Search, Buf1);
  nLen   := Length(Search);
  while (nIndex > 0 ) do
  begin
      Buf2 := Buf2 +Replace+ Copy(Buf1,1,nIndex - 1) ;
      Delete(Buf1,1,nIndex + nLen - 1 );
      nIndex := Pos(Search, Buf1);
  end;
  Buf2 := Buf2 + Buf1;
  Result := Buf2;
end;

{--------}
{TBWImage}
{--------}

/////////
procedure TBWImage.BlackWhite;
var
 X,Y,i      : integer;
 Colors     : PRGBColor;
 BufByte    : Byte;
 DoAutoMono : Boolean;
 MonoBuffer : Double	;
 Histgram   : array [0..255] of integer;
 Maxbyte,HistTotal,StartHistLoop,
 EndHistLoop,MainCount,nBlack,nWhite,
 nWidth,nHeight : integer;
begin

 if Empty then Exit;

 //
 DoAutoMono :=false;
 nWidth :=Width-1;
 nHeight:=Height-1;
 nBlack  :=0;
 nWhite  :=0;
 HistTotal := 0   ;
 pixelformat:=pf24bit;
 FillChar(Histgram,Sizeof(Histgram),0);

 //qXgO쐬
 for Y := 0 to  nHeight   do
 begin
    Colors:=ScanLine[Y];
    for X := 0 to nwidth  do
    begin
       BufByte:= Round((Colors[X].rgbtRed+Colors[X].rgbtGreen+Colors[X].rgbtBlue)/3 );
       Histgram[Bufbyte] := Histgram[Bufbyte] +1;
     end;
 end;

 //F̐L߂
 for i := 0 to 255 do
 begin
    if (i<=$7F) And (Histgram[i]<>0) then  inc(nBlack);
    if (i>=$80) And (Histgram[i]<>0) then  inc(nWhite);
 end;

 //qXgOgpĎo邩?
 if (nBlack =0) or (nWhite =0) then
     DoAutoMono:=True
 else
 begin
   if nBlack<nWhite then
   begin
      MonoBuffer:= nWhite/ nBlack;
      if MonoBuffer>2.50  then DoAutoMono:=True ;
   end
   else
   begin
      MonoBuffer:= nBlack/nWhite;
      if MonoBuffer>2.50  then DoAutoMono:=True ;
   end;
 end;

 //o
 if DoAutoMono then
 begin
    MainCount:=0;
    Maxbyte:=0;

    //s[No
    for i:=0 to 255 do
    begin
       If Histgram[i] > Maxbyte Then
       begin
           Maxbyte := Histgram[i] ;
           MainCount := i ;
       end;
    end;

    StartHistLoop :=MainCount;
    EndHistLoop   := StartHistLoop or 1 ;

    //͈͌o
    While HistTotal < Round((Width) * (height) / 2)   do
    begin
       If (StartHistLoop >= $00) And (StartHistLoop <= $FF) Then
       begin
           HistTotal := HistTotal + Histgram[StartHistLoop]  ;
           StartHistLoop := StartHistLoop - 1 ;
       end;
       If (EndHistLoop >= $00) And (EndHistLoop <= $FF) Then
       begin
           HistTotal := HistTotal + Histgram[EndHistLoop] ;
           EndHistLoop := EndHistLoop + 1;
       End;
    end;
  end;

  //C[W2K
  for Y := 0 to  nHeight   do
  begin
    Colors:=ScanLine[Y];
    for X := 0 to nwidth  do
    begin
       BufByte:= Round((Colors[X].rgbtRed+Colors[X].rgbtGreen+Colors[X].rgbtBlue)/3 ) ;
       if DoAutoMono then
       begin
         if (BufByte >= StartHistLoop) And (BufByte <= EndHistLoop) Then
         begin
            Colors[X].rgbtRed   :=$FF;
            Colors[X].rgbtGreen :=$FF;
            Colors[X].rgbtBlue  :=$FF;
         end
         else
         begin
             Colors[X].rgbtRed   :=$00;
             Colors[X].rgbtGreen :=$00;
             Colors[X].rgbtBlue  :=$00;
          end;
         end
         else
         begin
          if BufByte>=128 then
          begin
             Colors[X].rgbtRed   :=$FF;
             Colors[X].rgbtGreen :=$FF;
             Colors[X].rgbtBlue  :=$FF;
           end
           else
           begin
             Colors[X].rgbtRed   :=$00;
             Colors[X].rgbtGreen :=$00;
             Colors[X].rgbtBlue  :=$00;
           end;
         end;
        end;

  end;
  Monochrome  :=True;
  pixelformat :=pf1bit;
end;

/////////
procedure TBWImage.SaveToStream(Stream:TStream);
begin
  BlackWhite;
  inherited  SaveToStream(Stream);
end;

/////////
procedure TBWImage.Assign(Source: TPersistent);
begin
  inherited  Assign(Source);
  BlackWhite;
end;

{---------}
{TXBMImage}
{---------}

/////////
procedure TXBMImage.CreateBWPalette ;
var
  LogPalette: TMaxLogPalette;
begin
  //Black&Whitepbg쐬
  FillChar(LogPalette, SizeOf(LogPalette), 0);
  LogPalette.palVersion := $300;
  LogPalette.palNumEntries := 2;
  LogPalette.palPalEntry[0].peBlue  := 255;
  LogPalette.palPalEntry[0].peGreen := 255;
  LogPalette.palPalEntry[0].peRed   := 255;
  Palette := CreatePalette(PLogPalette(@LogPalette)^);
end;

////////
function TXBMImage.DoIntelOder(Value :byte):byte;
Var
 Buf      : array[0..3]of byte;
 BufByte  : byte;
 HiByte,LoByte  :byte;
begin
   //oCgI[_[CeI[_[ɂ(fR[h)
   //(j@1010 1100 -> 0011 0101

   if (Value=$FF) or (Value=$00) then
   begin
     Result:=Value;
     Exit;
   end;

   //4bitϊ
   BufByte:=Value And $F0 ;
   if ((BufByte shl 3) And ($80)) =$80 then
     Buf[0] := $80
   else
     Buf[0] := $00;
   if ((BufByte shl 2) And ($80)) =$80 then
     Buf[1] := $40
   else
     Buf[1] := $00;
   if ((BufByte shr 2) And ($10)) =$10 then
     Buf[2] := $20
   else
     Buf[2] := $00;
   if ((BufByte shr 3) And ($10)) =$10 then
     Buf[3] := $10
   else
     Buf[3] := $00;
   HiByte :=Buf[0] or Buf[1] or Buf[2] or Buf[3] ;

   //4bitϊ
   BufByte:=Value And $0F;
   if ((BufByte shl 3) And ($08)) =$08 then
     Buf[0] := $08
   else
     Buf[0] := $00;
   if ((BufByte shl 2) And ($08)) =$08 then
     Buf[1] := $04
   else
     Buf[1] := $00;
   if ((BufByte shr 2) And ($01)) =$01 then
     Buf[2] := $02
   else
     Buf[2] := $00;
   if ((BufByte shr 3) And ($01)) =$01 then
     Buf[3] := $01
   else
     Buf[3] := $00;
     LoByte :=Buf[0] or Buf[1] or Buf[2] or Buf[3] ;

   Result :=(HiByte shr 4) or (LoByte shl 4) ;
end;

////////
function TXBMImage.GetBitmapSize(LineBuf :string): integer;
Var
 i       : integer;
 BufByte : array[0..4] of Byte;
 BufCount   : integer;
 Buffer     : integer;
begin
   BufCount :=0;
   FillChar(BufByte,Sizeof(BufByte),0);

   //̒Width,HeightTBȂꍇ-1
   for i :=0 to Length(Linebuf) do
   begin
      Buffer := StrToIntDef(Copy(Linebuf,i,1),-1);
      if Buffer<>-1 then
      begin
        BufByte[BufCount]  := Buffer;
        inc(BufCount);
      end;
   end;

   if BufCount<>0 then
   begin
      Case BufCount of
        1 : Result :=  BufByte[0] ;
        2 : Result :=  (BufByte[0]*10)+BufByte[1] ;
        3 : Result :=  (BufByte[0]*100)+(BufByte[1]*10) +(BufByte[2]);
        4 : Result :=  (BufByte[0]*1000)+(BufByte[1]*100) +(BufByte[2]*10)+(BufByte[3]) ;
      else
        Result:=-1;
      end;
   end
   else
    Result:=-1;
end;

/////////
procedure TXBMImage.LoadFromStream(Stream: TStream);
Var
 StringStream   : TStringStream;
 Buf            : String;
 nSize          : integer;
 Line8          : PByte;
 X,Y            : integer;
 Count          : integer;
 BufByte        : Byte;
 DelIndex       : integer;
 nWidth,nHeight : integer;
 ModWidth       : integer;
 Header         : integer;
begin
   //
   Handle:=0;
   StringStream :=TStringStream.Create('');
   StringStream.CopyFrom(Stream,0);
   Buf :=StringStream.DataString;
   Buf:=  AnsiStrLower(Pchar(Buf));
   StringStream.Free;

   //wb_̊mF
   Header :=Pos('#define',Buf);
   if Header=0 then
     raise Exception.Create('Not XBM File')
   else
   begin
     //擪ɕsȕꍇ폜
     if Header<>1 then  Delete(Buf,1,Header-1);

     //摜̉擾
     DelIndex   :=Pos(#13#10,Buf);
     nSize :=GetBitmapSize(Copy(Buf,1,DelIndex));
     if nSize<>-1 then
     begin
      WIdth :=nSize;
      Delete(Buf,1,DelIndex+1);
     end
     else
      raise Exception.Create('Can not Read Image Width') ;

     //wb_̊mF(sȕꍇ폜)
     Header :=Pos('#define',Buf);
     if Header<>1 then  Delete(Buf,1,Header-1);

     //摜̏c擾
     DelIndex   :=Pos(#13#10,Buf);
     nSize :=GetBitmapSize(Copy(Buf,1,DelIndex));

     if nSize<>-1 then
      Height :=nSize
     else
      raise Exception.Create('Can not Read Image Height') ;

   end;

   //u{v܂ł̕폜
   Delete(Buf,1,Pos('{' ,buf));
   //&sR[h폜
   Buf :=_ReplaceString(_ReplaceString(_ReplaceString(buf,' ',''),#13,''),#10,'');

   nWidth  :=(Width div 8)-1;
   nHeight :=Height-1;
   ModWidth :=(Width mod 8);
   PixelFormat:=pf1bit;
   CreateBWPalette;
   Count :=3;

  try
     //sNZf[^̓ǂݍ
     for Y := 0 to nHeight do
     begin
         Line8 := ScanLine[Y];
         for X := 0 to nWidth do
         begin
           BufByte  := DoIntelOder(Strtoint('$'+Copy(Buf,Count,2)));
           inc(Count,5);
           Line8^ :=  BufByte;
           Inc(Line8);
         end;
         if ModWidth <> 0 then
         begin
           BufByte  := DoIntelOder(Strtoint('$'+Copy(Buf,Count,2)));
           inc(Count,5);
           Line8^ :=  BufByte;
         end;
      end;
   except
    Handle:=0;
    raise Exception.Create('Can not Read Image Data') ;
   end;

end;

/////////
procedure TXBMImage.SaveToStream(Stream: TStream);
Var
 X,Y           : integer;
 Lines         : pRGBColor;
 BMP           : TBItmap;
 nWidth,nHeight      : integer;
 Buf                 : string;
 StringStream        : TStringStream;
 BufByte,WriteByte   : Byte;
 Count               : integer;
 BW                  : TBWImage;
begin
  BMP :=TBitmap.Create;
  BMP.Assign(Self);

  BW :=TBWImage.Create;
  BW.Assign(BMP);
  BMP.Assign(BW);
  BW.Free;

  BMP.Pixelformat:=pf24bit;
  nWidth  :=BMP.Width-1;
  nHeight :=BMP.Height-1;
  StringStream  := TStringStream(Stream);

  //񏑂
  Buf :=XBMWidth+' '+inttostr(BMP.Width)+#13#10;
  StringStream.Writestring(Buf);
  Buf :=XBMHeight+' '+inttostr(BMP.Height)+#13#10;
  StringStream.Writestring(Buf);
  StringStream.Writestring(Header);

  //
  Count       :=0;
  WriteByte   :=0;
  Buf         :='';

 try
  for Y := 0 to nHeight  do
  begin
    Lines:=BMP.ScanLine[Y];

    for X := 0 to nWidth do
    begin
         //2K(0-255͈̔)
         if (Lines[X].rgbtRed<=128 ) And (Lines[X].rgbtGreen<=128 ) And
             (Lines[X].rgbtBlue<=128 ) then
            BufByte:=$01
         else
            BufByte:=$00;

         //ő7rbg܂ōVtg(0-255͈̔͂̈)
         inc(Count);
         BufByte := BufByte shl (8-Count)  ;
         WriteByte:= WriteByte or BufByte;

         if (Count)= 8 then
         begin
             Buf :=C_Hex+ IntToHex(DoIntelOder(WriteByte),2)+',';
             StringStream.WriteString(Buf) ;
             WriteByte  :=0;
             Count      :=0;
             Buf        :='';
         end;

         //C̏Iŗ]肪ꍇ͏
         if (X= nWidth) And (Count<>0)  then
         begin
             Buf :=C_Hex+ IntToHex(DoIntelOder(WriteByte),2)+',';
             StringStream.WriteString(Buf) ;
             WriteByte  :=0;
             Count      :=0;
             Buf        :='';
         end;
    end;

  end;

  //ŏIwb_[̏
  StringStream.Position :=StringStream.Position-1;
  StringStream.WriteString(LastString);

  finally
   BMP.FRee;
 end;

end;

Initialization
	TPicture.RegisterFileFormat('xbm', 'X-Bitmap', TXBMImage);
Finalization
	TPicture.UnregisterGraphicClass(TXBMImage);

end.
